/*
 * EndEffectorBehavior.h
 *
 *  Created on: 05.05.2012
 *      Author: sergey
 */

#ifndef ENDEFFECTORBEHAVIOR_H_
#define ENDEFFECTORBEHAVIOR_H_

#include "Behaviour.h"

class EndEffectorBehavior : public Behaviour
{
public:
  enum {
    NO_TASK,
    GOAL_AIM_AT_POINT,
    GOAL_PRESERVE_ORIENTATION,
    END_GOAL_TYPE
  } EEgoalType;

  EndEffectorBehavior(Transformhandler* ReferenceTransformhandler,
                      TaskLevelController* OwningTaskLevelController);
  virtual ~EndEffectorBehavior();
  void setGoalPoint(const btVector3& goalPoint);
  void setGoalOrientation(const btVector3& orient);
  const torqueVector& getTorque();
  btVector3 getGoal(uint& goalType);

private:
  uint TaskType;
  void calculateReferenceAcceleration();
  btVector3 desiredFixedOrientation;
  btVector3 pointToAim;
};

#endif /* ENDEFFECTORBEHAVIOR_H_ */
