/*
 * GlobalBehaviour.h
 *
 *  Created on: 18.11.2011
 *      Author: sergey
 */

#ifndef GLOBALBEHAVIOUR_H_
#define GLOBALBEHAVIOUR_H_

#include "Behaviour.h"

class TaskLevelController;

#define GLOBALBEHAVIOUR_MAXSPEED 0.5

/** @brief Computes base torques to bring the base to desired position
 * 	and (optionally) orientation*/
class GlobalBehaviour: public Behaviour {
public:
	GlobalBehaviour(Transformhandler* ReferenceTransformhandler,
			 TaskLevelController* OwningTaskLevelController);
	virtual ~GlobalBehaviour();
	void setGoalPoint(const btVector3& goalPoint);
	btVector3 getGoalPoint();
	void disableBehaviour();

protected:
//	  inline int signof(double a) { return (a != 0) ? (a<0 ? -1 : 1) : 0; };
//
	  void calculateReferenceAcceleration();

	  /** @brief stores the coordinates of goal point or a point belonging to a plane or line*/
	  btVector3 myGoalPoint;

};

#endif /* GLOBALBEHAVIOUR_H_ */
