#ifndef __KINEMATICBEHAVIOUR_H__
#define __KINEMATICBEHAVIOUR_H__

#include <Eigen/Core>
#include <iostream>
#include <tf/transform_listener.h>
#include "Behaviour.h"

#define KINEMATICBEHAVIOUR_MAXSPEED 0.2


/**
   @brief This behaviour provides torques that keep the robot joints
   away from their kinematic limits.
*/
class KinematicBehaviour : public Behaviour {
 public:
  KinematicBehaviour(Transformhandler* ReferenceTransformhandler,
		  TaskLevelController* OwningTaskLevelController,
		  double limit_zone=0.1);
  virtual ~KinematicBehaviour();
  void setMultiplier(double x);
  const torqueVector& getTorque();
 protected:
  void calculateReferenceAcceleration();

  double myMultiplier;
  double CloseToLimitZone;
  Eigen::MatrixXd myJointLimits;
  Eigen::VectorXi jointIsLimited;
};

#endif /*__KINEMATICBEHAVIOUR_H__*/
