/*
 * Cell.h
 *
 *  Created on: 11.03.2012
 *      Author: sergey
 */

#ifndef CELL_H_
#define CELL_H_

#include "Configuration.h"
#include <btBulletDynamicsCommon.h>
#include <vector>

using namespace std;

class Cell
{
public:
  Cell(btVector3 center)
  {
    centerPosition = center;

    //rounding down so we have number in format a.aaa
    //rounding down so we have number in format a.aaa
    int a,b,c;
    a = round(center[0]*1000);
    b = round(center[1]*1000);
    c = round(center[2]*1000);
    /*
     * ID_number structure: XxxxYyyyZzzzz
     * X - sign of centerPosition.x (1 for negative)
     * _xxx - value of centerPosition.x in mm (should be:  centerPosition.x <1)
     * Y - sign of centerPosition.y (1 for negative)
     * _yyy - value of centerPosition.y in mm. (should be:  centerPosition.x <1)
     * Z- sign of centerPosition.y (1 for negative)
     * _zzzz - value of centerPosition.z in mm
     */
    long int ID = abs(c) + abs(b*100000) + fabs(a*1e9);
    if (c < 0)
      ID += 1e4;
    if (b < 0)
      ID += 1e8;
    if (a < 0)
      ID += 1e12;
    ID_number = ID;
  }
  Cell() {};
  virtual ~Cell()   {};

  template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
            ar & BOOST_SERIALIZATION_NVP(ID_number);
            ar & BOOST_SERIALIZATION_NVP(Config_ID_list);
            ar & BOOST_SERIALIZATION_NVP(centerPosition.m_floats);
    }

  inline void addConfig(pair<long int, uint> a)
    {    Config_ID_list.push_back(a);   };

  inline long int getId() {return ID_number;};

  inline vector< pair<long int,uint> >* getConfigList() {return &Config_ID_list;};

  inline btVector3 getCenter() {return centerPosition;};

private:
  //stores the configurations, that belong to this cell
  //The "long int" - ID of a node; uint - determines which configuration from the node
  vector< pair<long int,uint> > Config_ID_list;
  long int ID_number;
  btVector3 centerPosition;

};

#endif /* CELL_H_ */
