/*
 * Configuration.h
 *
 *  Created on: 11.03.2012
 *      Author: sergey
 */

#ifndef CONFIGURATION_H_
#define CONFIGURATION_H_

#include "matrixDefinition.h"
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>

class Configuration
{
public:
  Configuration()
  {
    exist=false;
    invalid=0;
   // task_consistent = false;
    config.setZero();
  }
  Configuration(cVector conf)
  {
    exist=true;
    invalid=0;
    //task_consistent = false;
    config = conf;
  };
  inline  cVector  getCvector() const {return config;};
  inline  cVector  getCvector() {return config;};
  void setCvector(cVector conf) {
    config = conf;
    exist = true;
    invalid = 0;
  };

  bool exist;
  int invalid;
  //bool task_consistent;
  template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
            ar & BOOST_SERIALIZATION_NVP(exist);
            ar & BOOST_SERIALIZATION_NVP(invalid);
            //ar & BOOST_SERIALIZATION_NVP(task_consistent);
            ar & BOOST_SERIALIZATION_NVP(config(0));
            ar & BOOST_SERIALIZATION_NVP(config(1));
            ar & BOOST_SERIALIZATION_NVP(config(2));
            ar & BOOST_SERIALIZATION_NVP(config(3));
            ar & BOOST_SERIALIZATION_NVP(config(4));
            ar & BOOST_SERIALIZATION_NVP(config(5));
            ar & BOOST_SERIALIZATION_NVP(config(6));

    }
private:
  cVector config;
};

#endif /* CONFIGURATION_H_ */
