/*
 * Node.h
 *
 *  Created on: 14.03.2012
 *      Author: sergey
 */

#ifndef NODE_H_
#define NODE_H_

#include <btBulletDynamicsCommon.h>
#include "Cell.h"
#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>

struct Edge_prop
{
  template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
            ar & BOOST_SERIALIZATION_NVP(weight);
    }
  Edge_prop() {weight=1;};
  Edge_prop(double a) {weight = a;};
  double weight;
};
struct Graph_prop
{
  double step_size;
};

struct Node
{
  long int ID;
  btVector3 position;
  enum{X_POS,X_NEG,Y_POS,Y_NEG,Z_POS,Z_NEG, NUMBER_OF_CONFIGS};
  Configuration config[6];
  template<class Archive>
    void serialize(Archive & ar, const unsigned int version)
    {
            ar & BOOST_SERIALIZATION_NVP(ID);
            ar & BOOST_SERIALIZATION_NVP(position.m_floats);
            ar & BOOST_SERIALIZATION_NVP(config);
    }

  void FormIDfromPos()
  {
    //rounding down so we have number in format a.aaa
    btVector3 buf;
    buf[0] = round(position[0]*1000)/1000;
    buf[1] = round(position[1]*1000)/1000;
    buf[2] = round(position[2]*1000)/1000;
    /*
     * ID_number structure: XxxxYyyyZzzzz
     * X - sign of centerPosition.x (1 for negative)
     * _xxx - value of centerPosition.x in mm (should be:  centerPosition.x <1)
     * Y - sign of centerPosition.y (1 for negative)
     * _yyy - value of centerPosition.y in mm. (should be:  centerPosition.x <1)
     * Z- sign of centerPosition.y (1 for negative)
     * _zzzz - value of centerPosition.z in mm
     */
    ID = fabs(buf.getZ())*1e3 + fabs(buf.getY())*1e8 + fabs(buf.getX())*1e12;
    if (buf.getZ() < 0)
      ID += 1e4;
    if (buf.getY() < 0)
      ID += 1e8;
    if (buf.getX() < 0)
      ID += 1e12;
  }
};

#endif /* NODE_H_ */
