/*
 * ObstaclesHandler.h
 *
 *  Created on: 02.05.2012
 *      Author: sergey
 */

#ifndef OBSTACLESHANDLER_H_
#define OBSTACLESHANDLER_H_

#include "Obstacle.h"
#include "ros/ros.h"
#include "Cell.h"
#include <vector>
#include "Planner.h"

class Planner;
using namespace std;

class ObstaclesHandler
{
public:
  ObstaclesHandler(ros::NodeHandle* n, Planner* planner);
  virtual ~ObstaclesHandler();

  Obstacle* addObstacle(uint type, btVector3 dim, btVector3 cent, btQuaternion rot = btQuaternion(btVector3(0,0,1),0));
  Obstacle* addObstacle(uint type, btVector3 dim, btTransform trans);
  bool moveObstacle(Obstacle* obst, btVector3 newCenter, btQuaternion newRot);
  bool moveObstacle(Obstacle* obst, btVector3 newCenter);
  bool moveObstacle(Obstacle* obst, btQuaternion newRot);
  bool deleteObstacle(Obstacle* obst);
  vector<Obstacle*> getObstacles();

private:
  void updateObstaclesRviz(bool clear = false);
  long int FormIDfromPos(btVector3 position);
  map<long int, Cell>* myCells;
  Planner* myPlanner;
  ros::Publisher obstacle_publisher;
  vector<Obstacle*> myObstacles;
  ros::NodeHandle* node_handler;
  Obstacle* manipulator_base;
};

#endif /* OBSTACLESHANDLER_H_ */
