/*
 * ConfToCellsMapper.h
 *
 *  Created on: 11.03.2012
 *      Author: sergey
 */

#ifndef CONFTOCELLSMAPPER_H_
#define CONFTOCELLSMAPPER_H_

#include <vector>
#include <set>
#include <map>
#include <btBulletDynamicsCommon.h>
#include "../Cell.h"
#include "../Node.h"
#include "../Transformhandler.h"

#define NUMBER_OF_POINTS 50

using namespace std;

class ConfToCellsMapper
{
public:
  ConfToCellsMapper(map<long int, Cell>* cell_array);
  virtual ~ConfToCellsMapper();
  void mapNodeToCells(const Node &n, double cell_size);

private:
  set<long int> mapConfigurationToCells(const Configuration &conf, double cell_size);

  vector<btVector3> link_1_points;
  vector<btVector3> link_2_points;
  vector<btVector3> link_3_points;
  vector<btVector3> link_4_points;
  vector<btVector3> link_5_points;
  vector<btVector3> link_6_points;
  vector<btVector3> link_7_points;

  map<long int, Cell>* cells;

  Transformhandler* myTransformhandler;

};

#endif /* CONFTOCELLSMAPPER_H_ */
