/*
 * IKSolver.h
 *
 *  Created on: 05.03.2012
 *      Author: sergey
 */

#ifndef IKSOLVER_H_
#define IKSOLVER_H_

#include <urdf/model.h>
#include "../Transformhandler.h"
#include "../Node.h"

class IKSolver
{
public:
  IKSolver(urdf::Model my_model);
  virtual ~IKSolver();
  bool solveIKtask(btVector3 point, btVector3 orient, Configuration& conf);
  void computeIKForNode(Node &n);
private:
  double l1,l2,l3,l4; //lengths of main manipulator segments
  Eigen::MatrixXd JointLimits;
  Transformhandler* transforms;
};

#endif /* IKSOLVER_H_ */
