/*
 * RobotController.h
 *
 *  Created on: 19.04.2012
 *      Author: sergey
 */

#ifndef ROBOTCONTROLLER_H_
#define ROBOTCONTROLLER_H_

//#include "Behaviours/GlobalBehaviour.h"
#include "TaskLevelController.h"
#include "Transformhandler.h"

#include "RobotVisualPublisher.h"


#define CONTROLLER_FREQ 40

class TaskLevelController;
class GlobalBehaviour;
class EndEffectorBehavior;
class AvoidanceBehaviour;
class ObstaclesHandler;

class RobotController
{
public:
  RobotController(ros::NodeHandle* n);
  virtual ~RobotController();
  Transformhandler* getTransformhandler();
  void setPositionGoal(btVector3 goal);
  GlobalBehaviour* getGlobalBehaviour();
  EndEffectorBehavior* getEndEffectorBehavior();
  //AvoidanceBehaviour* getAvoidanceBehaviour();
  void ResetConfiguration(cVector newConf);
  void setObstacleHandler (ObstaclesHandler* handler);



private:
  void publishEEpos(btVector3 pos);
  static void* _run(void*);
  void run();
  TaskLevelController* myTLC;
  Transformhandler* myTransformhandler;
  RobotVisualPublisher* rvizPublisher;
  GlobalBehaviour* myGlobalBehaviour;
  EndEffectorBehavior* myEndEffectorBehavior;
  std::vector<AvoidanceBehaviour*> myAvoidanceBehaviours;
  ros::NodeHandle* node_handler;
  ros::Publisher EndEffectorPosPublisher;
};

#endif /* ROBOTCONTROLLER_H_ */
