/*
 * RobotVisualPublisher.cpp
 *
 *  Created on: 13.02.2012
 *      Author: sergey
 */

#include "RobotVisualPublisher.h"


RobotVisualPublisher::RobotVisualPublisher(ros::NodeHandle* handler)
{
  node_handler = handler;
  joint_publisher = handler->advertise<sensor_msgs::JointState>("joint_states", 0);

  joint_state.name.resize(7);
  joint_state.position.resize(7);
  joint_state.name[0] ="schunk_1_joint";
  joint_state.name[1] ="schunk_2_joint";
  joint_state.name[2] ="schunk_3_joint";
  joint_state.name[3] ="schunk_4_joint";
  joint_state.name[4] ="schunk_5_joint";
  joint_state.name[5] ="schunk_6_joint";
  joint_state.name[6] ="schunk_7_joint";

  fix_frame_transform.header.frame_id = "fix";
  fix_frame_transform.child_frame_id = "base";
  fix_frame_transform.transform.translation.x=0;
  fix_frame_transform.transform.translation.y=0;
  fix_frame_transform.transform.translation.z=0;
  fix_frame_transform.transform.rotation = tf::createQuaternionMsgFromYaw(0);
}

RobotVisualPublisher::~RobotVisualPublisher()
{}

void RobotVisualPublisher::PublishJointState(cVector newConf)
{
  fix_frame_transform.header.stamp=ros::Time::now();
  tf_broadcaster.sendTransform(fix_frame_transform);

  joint_state.header.stamp = ros::Time::now();
  for (int i=0; i<newConf.rows(); i++)
    joint_state.position[i] = newConf(i,0);
  if(node_handler->ok())
    joint_publisher.publish(joint_state);
}




