/*
 * RobotVisualPublisher.h
 *
 *  Created on: 13.02.2012
 *      Author: sergey
 */

#ifndef ROBOTVISUALPUBLISHER_H_
#define ROBOTVISUALPUBLISHER_H_

#include "ros/ros.h"
#include <sensor_msgs/JointState.h>
#include <tf/transform_broadcaster.h>
#include "matrixDefinition.h"

class RobotVisualPublisher
{
public:
  RobotVisualPublisher(ros::NodeHandle* handler);
  virtual ~RobotVisualPublisher();
  void PublishJointState(cVector newConf);

private:
  ros::Publisher joint_publisher;
  tf::TransformBroadcaster tf_broadcaster;

  sensor_msgs::JointState joint_state;
  geometry_msgs::TransformStamped fix_frame_transform;

  ros::NodeHandle* node_handler;

};

#endif /* ROBOTVISUALPUBLISHER_H_ */
