#ifndef __SCHUNK_TRANSFORMHANDLER_H__
#define __SCHUNK_TRANSFORMHANDLER_H__

#include "Transformhandler.h"

#include <pthread.h>


/**
   @brief Manages the conversion "configuration vector -> transform" for the
   Schunk Jr with attached LWA arm
 */
class SchunkTransformhandler : public Transformhandler {
 public:
  SchunkTransformhandler();
  virtual ~SchunkTransformhandler();
  void updateTransforms();
  std::vector<btVector3> getAxes();
//  std::vector<btVector3> getOrigins();
  void printData();

 protected:
  void InitJointInertia();
  void CalculateJacobian();
  void InitJointLimits();
  bool jacobianCalculated;

};

#endif /*__SEEKUR_TRANSFORMHANDLER_H__*/
