#ifndef MATRIXDEFINITION_H_
#define MATRIXDEFINITION_H_


#include <Eigen/Core>
#include <Eigen/Array>
#include <exception>

typedef Eigen::Matrix<double, 7, 1> cVector;
typedef Eigen::Matrix<double, 7, 1> torqueVector;

#define GRID_STEP 0.05
#define CELL_GRID_STEP 0.03
#define MIN_X_RANGE -0.8
#define MAX_X_RANGE 0.8
#define MIN_Y_RANGE -0.8
#define MAX_Y_RANGE 0.8
#define MIN_Z_RANGE -0.15
#define MAX_Z_RANGE 1.2

const uint DIM_X = (uint) ((MIN_X_RANGE - MAX_X_RANGE) / GRID_STEP + 1);
const uint DIM_Y = (uint) ((MIN_Y_RANGE - MAX_Y_RANGE) / GRID_STEP + 1);
const uint DIM_Z = (uint) ((MIN_Z_RANGE - MAX_Z_RANGE) / GRID_STEP + 1);

//const double step = 0.05;
//const double min_X_range = -0.8;
//const double max_X_range = 0.8;
//const double min_Y_range = -0.8;
//const double max_Y_range = 0.8;
//const double min_Z_range = -0.15;
//const double max_Z_range = 1.2;
//
//const uint dimX = (uint) (max_X_range - min_X_range) / step + 1;
//const uint dimY = (uint) (max_Y_range - min_Y_range) / step + 1;
//const uint dimZ = (uint) (max_Z_range - min_Z_range) / step + 1;

////structure for "go out of the program" exception
//class task_completed_exception: public std::exception
//{};

#endif
